/**************************************************************************
* This file contains all the JavaScript needed by settings.xul.
* A lot of the ideas here are borrowed from the rssreader extension
**************************************************************************/
var gNameArc;			    // Arc pointing to Name field in bookmarks
var selectedFolderId;		    // The ID of the folder selected by the user
var prefFolder;			    // The folder name as set in preferences
var prefUpdateInterval;		    // Update interval as set in preferences
// var prefSortReverse;		    // Sorting order as set in preferences
var prefOpenInNew;		    // Display settings as set in preferences
var menuList;			    // The pulldown menulist in the dialog
var updateIntervalElement;	    // The text box containing the update interval
var openInNewElement;
var showDetailsElement;
var strbundle;

// The main window's subscriptions tree passed to us as an argument
var bTree;
var caller = window.opener;

bTree = window.arguments[0];

/**************************************************************************
* User has clicked OK.  Find out which item was selected, set it in
* prefs.js and return
**************************************************************************/
function doOK() {
    // Find out which element was selected in bookmarksFeedsFolderMenu
    menuList = document.getElementById("bookmarkFeedsFolder");
    updateIntervalElement = document.getElementById("update-interval");
    openInNewElement = document.getElementById("open-in-new");
    showDetailsElement = document.getElementById("show-details");

    var menuSelectedElement = menuList.selectedIndex;
    var updateIntervalSet = parseInt(updateIntervalElement.value);

    // var sortOld2NewElement = document.getElementById("sort-old2new");
    // var sortNew2OldElement = document.getElementById("sort-new2old");
    // var sortReverse = (sortOld2NewElement.selected) ? true : false;

    if (menuSelectedElement <= 0) {
	// User has not selected a bookmarks folder
	alert(strbundle.GetStringFromName("errnofolderselected"));
	return false;
    } else  {
	if (updateIntervalSet > 0 && updateIntervalSet < 100 ) {
	    try {
		// Set the preferences
		setPrefValue("extensions.habarixenu.feeds_folder", "str", selectedFolderId);
		setPrefValue("extensions.habarixenu.update_interval", "int", updateIntervalSet);
		setPrefValue("extensions.habarixenu.show_details", "bool", showDetailsElement.checked);
		setPrefValue("extensions.habarixenu.open_in_new", "bool", openInNewElement.checked);

		if (caller && bTree) {
		    // Set the variables in habarixenu.js
		    caller.updateInterval = updateIntervalSet;
		    caller.showDetail = showDetailsElement.checked;

		    // Make the feeds tree point to the correct place
		    bTree.setAttribute("ref", selectedFolderId);
		    bTree.builder.rebuild();
		}
	    } catch(e) {
		alert(strbundle.GetStringFromName("errorsettingprefs") + " : " + e);
		return false;
	    }
	} else {
	    alert(strbundle.GetStringFromName("errbadupdateinterval"));
	    return false;
	}
    }

    return true;
}


/**************************************************************************
* This function gets called when the user selects an item in the pulldown
* menu.  We set a variable with the ID of the selected element
**************************************************************************/
function selectBookmarkFolder(aEvent) {
    selectedFolderId = aEvent.target.id;
}


/**************************************************************************::
* User has clicked Cancel.
**************************************************************************/
function doCancel() {
    return;
}


/**************************************************************************
* Populate the tree from the Datasource. See above for consts that we set
* This function gets called on the settings editor's onload event
**************************************************************************/
function buildMenuFromDataSource() {
    // Initialize some stuff in chrome://communicator/content/bookmarks/bookmarks.js
    initServices();
    initBMService();

    strbundle=srGetStrBundle("chrome://habarixenu/locale/strings.properties");

    // Was any folder set as the preferred folder in prefs
    prefFolder = getPrefValue("extensions.habarixenu.feeds_folder", "str", "NC:BookmarksRoot");
    prefUpdateInterval = getPrefValue("extensions.habarixenu.update_interval", "int", 60);
    prefOpenInNew = getPrefValue("extensions.habarixenu.open_in_new", "bool", true);
    prefShowDetails = getPrefValue("extensions.habarixenu.show_details", "bool", false);
    // prefSortReverse = getPrefValue("extensions.habarixenu.sort_reverse", "bool", false);
    
    menuList = document.getElementById("bookmarkFeedsFolder");
    var menuPopup = document.getElementById("bookmarksFeedsFolderMenu");

    gNameArc = RDF.GetResource(NC_NS + "Name");

    // Remove any children menuPopup might have
    while (menuPopup.hasChildNodes()) {
	menuPopup.removeChild(menuPopup.firstChild);
    }

    var newMenuItem = document.createElementNS(XUL_NS, "menuitem");
    newMenuItem.setAttribute("label", "Bookmarks");
    newMenuItem.setAttribute("id", "NC:BookmarksRoot");
    menuPopup.appendChild(newMenuItem);

    var bookmarksRoot = RDF.GetResource("NC:BookmarksRoot");

    // Descend into this folder and read all its contents
    descendFolder(menuPopup, bookmarksRoot, 1, prefFolder);

    // Now set the update interval
    updateIntervalElement = document.getElementById("update-interval");
    updateIntervalElement.value = prefUpdateInterval;

    /*
    // Now set the proper sort order
    var selectedSortElement = (prefSortReverse) ? document.getElementById("sort-old2new") : document.getElementById("sort-new2old");
    selectedSortElement.selected = true;
    */

    // If tabbed browsing is properly configured disable the 'Optimize Tabbed Browsing' button
    if (getPrefValue("browser.tabs.loadInBackground", "bool", false) && getPrefValue("browser.tabs.opentabfor.middleclick", "bool", false)) {
	var tabbedBtn = document.getElementById("tabbrowsing-btn");
	tabbedBtn.disabled = true;
    }

    // Disable uninstall button if Firefox
    if (navigator.userAgent.indexOf("irefox") != -1) {
	var uninstallBtn = document.getElementById("uninstall-btn");
	uninstallBtn.disabled = true;

	var displayWizPage = document.getElementById("wizid3");
	displayWizPage.next = "wizpage5";
    }

    // Check or uncheck the Display Preference
    openInNewElement = document.getElementById("open-in-new");
    openInNewElement.checked = prefOpenInNew;

    // openInNewElement.checked = (prefOpenInSame) ? true : false;

    showDetailsElement = document.getElementById("show-details");
    showDetailsElement.checked = prefShowDetails;
}


/**************************************************************************
* A recursive function that we will use to descend into each folder and
* subfolder of the bookmarks tree and create menuitems for each folder
**************************************************************************/
function descendFolder(aPopup, aFolder, aDepth) {
    RDFC.Init(BMDS, aFolder);

    var children = RDFC.GetElements();
    while (children.hasMoreElements()) {
	var curr = children.getNext();
	if (RDFCU.IsContainer(BMDS, curr)) {
	    curr = curr.QueryInterface(Components.interfaces.nsIRDFResource);
	    var element = document.createElementNS(XUL_NS, "menuitem");
	    var name = BMDS.GetTarget(curr, gNameArc, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	    var indentation = new Array(aDepth + 1).join("  ");
	    element.setAttribute("label", indentation + name);
	    element.setAttribute("id", curr.Value);
	    aPopup.appendChild(element);
	    if (curr.Value == prefFolder) {
		// This item is currently set in prefs as the preferred folder
		// select it
		menuList.selectedItem = element;
		selectedFolderId = prefFolder;
	    }
	    descendFolder(aPopup, curr, ++aDepth);
	    --aDepth;
	}
    }
}


/**************************************************************************
* User has clicked Uninstall.
**************************************************************************/
function uninstallHX() {
    if (confirm(strbundle.GetStringFromName("uninstallconfirm"))) {
	var oExtUninstall = new ExtensionUninstall("urn:mozilla:package:habarixenu");
	var success = oExtUninstall.uninstall();
	oExtUninstall.showLogDialog(true, opener);
	window.opener.close();
	window.close();
    } else {
	alert(strbundle.GetStringFromName("uninstallcancel"));
    }
}

/**************************************************************************
* User is asking us to set tabbed browsing appropriately
**************************************************************************/
function setTabbedBrowsing() {
    if (confirm(strbundle.GetStringFromName("settabbrowsingconfirm"))) {
	try {
	    setPrefValue("browser.tabs.loadInBackgroung", "bool", true);
	    setPrefValue("browser.tabs.opentabfor.middleclick", "bool", true);

	    var tabbedBtn = document.getElementById("tabbrowsing-btn");
	    tabbedBtn.disabled = true;

	    alert(strbundle.GetStringFromName("settabbrowsingok"));
	} catch (e) {
	    dump("setTabbedBrowsing(): Error Setting tabbed browsing " + e + "\n");
	}
    }
}


/**************************************************************************
* This function gets called when the user clicks Next in Feed Settings
* screen. It is used to do data validation
**************************************************************************/
function doPage2DataValidation() {
    // Find out which element was selected in bookmarksFeedsFolderMenu
    menuList = document.getElementById("bookmarkFeedsFolder");
    updateIntervalElement = document.getElementById("update-interval");

    var menuSelectedElement = menuList.selectedIndex;
    var updateIntervalSet = parseInt(updateIntervalElement.value);

    if (menuSelectedElement <= 0) {
	// User has not selected a bookmarks folder
	alert(strbundle.GetStringFromName("errnofolderselected"));
	return false;
    }

    if (updateIntervalSet < 10 || updateIntervalSet >= 99 ) {
	alert(strbundle.GetStringFromName("errbadupdateinterval"));
	return false;
    } 
    return true;
}
